/**
 * 判断url是否是http或https
 * @param {string} path
 * @returns {Boolean}
 */
export function isHttp(url) {
  return url.indexOf('http://') !== -1 || url.indexOf('https://') !== -1
}

/**
 * 判断path是否为外链
 * @param {string} path
 * @returns {Boolean}
 */
export function isExternal(path) {
  return /^(https?:|mailto:|tel:)/.test(path)
}

/**
 * @param {string} str
 * @returns {Boolean}
 */
export function validUsername(str) {
  const valid_map = ['admin', 'editor']
  return valid_map.indexOf(str.trim()) >= 0
}

/**
 * @param {string} url
 * @returns {Boolean}
 */
export function validURL(url) {
  const reg = /^(https?|ftp):\/\/([a-zA-Z0-9.-]+(:[a-zA-Z0-9.&%$-]+)*@)*((25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]?)(\.(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9]?[0-9])){3}|([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]+\.(com|edu|gov|int|mil|net|org|biz|arpa|info|name|pro|aero|coop|museum|[a-zA-Z]{2}))(:[0-9]+)*(\/($|[a-zA-Z0-9.,?'\\+&%$#=~_-]+))*$/
  return reg.test(url)
}

/**
 * @param {string} str
 * @returns {Boolean}
 */
export function validLowerCase(str) {
  const reg = /^[a-z]+$/
  return reg.test(str)
}

/**
 * @param {string} str
 * @returns {Boolean}
 */
export function validUpperCase(str) {
  const reg = /^[A-Z]+$/
  return reg.test(str)
}

/**
 * @param {string} str
 * @returns {Boolean}
 */
export function validAlphabets(str) {
  const reg = /^[A-Za-z]+$/
  return reg.test(str)
}

/**
 * @param {string} email
 * @returns {Boolean}
 */
export function validEmail(email) {
  if (!email) return false
  const reg = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/
  return reg.test(email.trim())
}

/**
 * @param {string} str
 * @returns {Boolean}
 */
export function isString(str) {
  if (typeof str === 'string' || str instanceof String) {
    return true
  }
  return false
}

/**
 * @param {Array} arg
 * @returns {Boolean}
 */
export function isArray(arg) {
  if (typeof Array.isArray === 'undefined') {
    return Object.prototype.toString.call(arg) === '[object Array]'
  }
  return Array.isArray(arg)
}

/**
 * Visa 卡号校验
 */
export function validVisaCardNo(arg) {
  return /^(?:4[0-9]{12}(?:[0-9]{3})?)$/.test(arg)
}

/**
 * MasterCard 卡号校验
 */
export function validMasterCardNo(arg) {
  return /^(?:5[1-5][0-9]{14})$/.test(arg)
}

// 英名验证
export function enName(rule, value, callback) {
  if (!value) {
    callback(new Error('收件人必须是英文名字'))
  } else {
    const reg = /^[a-zA-Z0-9\s`~!@#$%^&*()_+-={}\[\]:;"'<>,.?/|\\]+$/ // 验证有空格的英文名
    if (value.length < 100 && reg.test(value)) {
      callback()
    } else {
      return callback(new Error('请输入英文名'))
    }
  }
}
// 英名验证
export function enName2(rule, value, callback) {
  if (!value) {
    callback()
  } else {
    const reg = /^[a-zA-Z0-9\s`~!@#$%^&*()_+-={}\[\]:;"'<>,.?/|\\]+$/ // 验证有空格的英文名
    if (value.length < 100 && reg.test(value)) {
      callback()
    } else {
      return callback(new Error('请输入英文名'))
    }
  }
}

// 英名地址验证
export function enAddress(rule, value, callback) {
  if (!value) {
    callback(new Error('地址必须是英文'))
  } else {
    //const reg = /^[a-zA-Z]+$/ // 验证没有空格的英文
    //const reg = /^[a-zA-Z0-9][A-Za-z0-9\s-]*[a-zA-Z0-9]*$/ // 验证有空格的英文
    //const reg = /^[\x20-\x7E]+$/; //ASCII码验证
    const reg = /^[a-zA-Z0-9\s`~!@#$%^&*()_+-={}\[\]:;"'<>,.?/|\\]+$/
    if (value.length < 100 && reg.test(value)) {
      callback()
    } else {
      return callback(new Error('请输入英文地址'))
    }
  }
}


// 英名地址验证
export function enAddress2(rule, value, callback) {
  if (!value) {
    callback()
  } else {
    const reg = /^[a-zA-Z0-9\s`~!@#$%^&*()_+-={}\[\]:;"'<>,.?/|\\]+$/
    if (value.length < 100 && reg.test(value)) {
      callback()
    } else {
      return callback(new Error('请输入英文地址'))
    }
  }
}

// 联系方式验证
export function validContact(rule, value, callback) {
  if (!value) {
    callback(new Error('联系方式不能出现中文'))
  } else {
    const reg = /^[a-zA-Z0-9\s`~!@#$%^&*()_+-={}\[\]:;"'<>,.?/|\\]+$/
    if (value.length < 100 && reg.test(value)) {
      callback()
    } else {
      return callback(new Error('请输入非中文联系方式'))
    }
  }
}

// 联系方式验证
export function validContact2(rule, value, callback) {
  if (!value) {
    callback()
  } else {
    const reg = /^[a-zA-Z0-9\s`~!@#$%^&*()_+-={}\[\]:;"'<>,.?/|\\]+$/
    if (value.length < 100 && reg.test(value)) {
      callback()
    } else {
      return callback(new Error('请输入非中文联系方式'))
    }
  }
}

// 邮编效验
export function zipCheck(rule, value, callback) {
  if (!value) return callback(new Error("邮编 必填"));
  if (value.length < 5 || value.length > 10)
    return callback(new Error("邮编长度必须为5-10位"))
  if (!/^[\d-]+$/.test(value))
    return callback(new Error("邮编无效，必须是数字"))
  callback()
}

// 邮编效验
export function zipCheck2(rule, value, callback) {
  if (!value) return callback(); 
  if (value.length < 5 || value.length > 10)
    return callback(new Error("邮编长度必须为5-10位"))
  if (!/^[\d-]+$/.test(value))
    return callback(new Error("邮编无效，必须是数字"))
  callback()
}